unit u_Autorizados;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, DBCtrls, Buttons, ExtCtrls, Grids, DBGrids, DB, DBTables,
  jpeg, ExtDlgs;

type
  TFAutorizados = class(TForm)
    GroupBox1: TGroupBox;
    Label2: TLabel;
    DBEdit1: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    Panel1: TPanel;
    novo: TBitBtn;
    gravar: TBitBtn;
    editar: TBitBtn;
    deletar: TBitBtn;
    cancelar: TBitBtn;
    navegador: TDBNavigator;
    BitBtn2: TBitBtn;
    DBGrid1: TDBGrid;
    dialogo: TSavePictureDialog;
    foto: TDBImage;
    ccarrega: TSpeedButton;
    climpa: TSpeedButton;
    Bevel1: TBevel;
    Label17: TLabel;
    Label1: TLabel;
    DBEdit2: TDBEdit;
    procedure novoClick(Sender: TObject);
    procedure editarClick(Sender: TObject);
    procedure deletarClick(Sender: TObject);
    procedure cancelarClick(Sender: TObject);
    procedure gravarClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure climpaClick(Sender: TObject);
    procedure ccarregaClick(Sender: TObject);
  private
    { Private declarations }
    procedure tabelavazia;
    procedure botoes;
    function duplicado(x:string):boolean;
  public
    { Public declarations }
  end;

var
  FAutorizados: TFAutorizados;
  velho:string;

implementation

uses u_DM;

{$R *.dfm}

function TFAutorizados.duplicado(x:string):boolean;
var
t: TTable;
begin
t := TTable.create(self);
with t do
begin
DatabaseName := 'Locadora'; {Nome do Alias}
TableName := 'Autorizados.db';
IndexFieldNames:='AutNome';
open;
if DataModule1.TAutorizados.State =DsEdit then
begin
if velho<>dbedit1.text then
begin
  if findkey([x]) then result:=true
  else result:=false;
end
else result := false;
end;

if DataModule1.TAutorizados.State =DsInsert then
begin
  if findkey([x]) then result:=true
  else result:=false;
end;
close;
free;
end;
end;


procedure TFAutorizados.tabelavazia;
begin
if datamodule1.TAutorizados.recordcount<1 then
begin
  novo.enabled:=true;
  editar.enabled:=false;
  deletar.enabled:=false;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
end
else begin
  novo.enabled:=true;
  editar.enabled:=true;
  deletar.enabled:=true;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  navegador.enabled:=true;
end;
end;

procedure TFAutorizados.botoes;
begin
novo.enabled:=false;
editar.enabled:=false;
deletar.Enabled:=false;
cancelar.enabled:=true;
gravar.enabled:=true;
navegador.enabled:=editar.enabled;
end;


procedure TFAutorizados.novoClick(Sender: TObject);
begin
datamodule1.DSAutorizados.AutoEdit:=true;
datamodule1.TAutorizados.Insert;
dbedit1.setfocus;
botoes;
climpa.Enabled := true;
ccarrega.Enabled := true;
end;

procedure TFAutorizados.editarClick(Sender: TObject);
begin
climpa.Enabled := true;
ccarrega.Enabled := true;
velho:=(dbedit1.text);
datamodule1.TAutorizados.Edit;
datamodule1.DSAutorizados.AutoEdit:=true;
//controla botoes enabled
botoes;
dbedit1.setfocus;
end;

procedure TFAutorizados.deletarClick(Sender: TObject);
begin
if MessageDlg('EXCLUIR O REGISTRO?', mtConfirmation, [mbYes,mbNo], 0)=mrYes then
begin
  datamodule1.TAutorizados.delete;
end;
tabelavazia;

end;

procedure TFAutorizados.cancelarClick(Sender: TObject);
begin
climpa.Enabled := false;
ccarrega.Enabled := false;
datamodule1.TAutorizados.Cancel;
//controla botoes enabled
novo.enabled:=true;
editar.enabled:=true;
deletar.enabled:=true;
cancelar.Enabled:=false;
gravar.Enabled:=false;
navegador.enabled:=true;
tabelavazia;
end;

procedure TFAutorizados.gravarClick(Sender: TObject);
begin
if (not duplicado(dbedit1.text)) then
begin
  novo.enabled:=true;
  editar.enabled:=true;
  deletar.enabled:=true;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  climpa.Enabled := false;
  ccarrega.Enabled := false;
  navegador.Enabled:=true;
  DataModule1.TAutorizados.FieldByName('AutCliCodigo').AsInteger :=
     DataModule1.TClientes.FieldByName('CliCodigo').AsInteger;
  DataModule1.TAutorizados.post;
  datamodule1.TAutorizados.IndexName := '';
  datamodule1.DSAutorizados.AutoEdit := False;
end
else begin
  showmessage('Registro duplicado');
  dbedit1.setfocus;
end;
end;

procedure TFAutorizados.BitBtn2Click(Sender: TObject);
begin
close;
end;

procedure TFAutorizados.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
if (datamodule1.TAutorizados.State = dsinsert) or (datamodule1.TAutorizados.State = dsEdit)
then datamodule1.TAutorizados.Cancel;
end;

procedure TFAutorizados.FormShow(Sender: TObject);
begin
datamodule1.TAutorizados.First;
datamodule1.DSAutorizados.AutoEdit:=false;
//controla botoes enabled
tabelavazia;
end;

procedure TFAutorizados.climpaClick(Sender: TObject);
begin
DataModule1.TAutorizados.FieldByName('AutFoto').Clear;
end;

procedure TFAutorizados.ccarregaClick(Sender: TObject);
begin
if dialogo.execute then

Foto.Picture.LoadFromFile(dialogo.FileName);
end;

end.
