unit u_Categoria;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBCtrls, StdCtrls, Buttons, ExtCtrls, Mask, DB, DBTables, Grids,
  DBGrids;

type
  TFCategoria = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    DBEdit10: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit1: TDBEdit;
    Panel1: TPanel;
    novo: TBitBtn;
    gravar: TBitBtn;
    editar: TBitBtn;
    deletar: TBitBtn;
    cancelar: TBitBtn;
    navegador: TDBNavigator;
    BitBtn2: TBitBtn;
    DBGrid1: TDBGrid;
    procedure novoClick(Sender: TObject);
    procedure editarClick(Sender: TObject);
    procedure deletarClick(Sender: TObject);
    procedure cancelarClick(Sender: TObject);
    procedure gravarClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure tabelavazia;
    procedure botoes;
    function duplicado(x:integer):boolean;
  public
    { Public declarations }
  end;

var
  FCategoria: TFCategoria;
  velho : integer;
  precovelho : real;
implementation

uses u_DM;

{$R *.dfm}

function TFCategoria.duplicado(x:integer):boolean;
var
t: TTable;
begin
t := TTable.create(self);
with t do
begin
DatabaseName := 'Locadora'; {Nome do Alias}
TableName := 'Categoria.db';
IndexFieldNames:='CatCodigo';
open;
if DataModule1.TCategoria.State =DsEdit then
begin
if velho<>strtoint(dbedit1.text) then
begin
  if findkey([x]) then result:=true
  else result:=false;
end
else result := false;
end;

if DataModule1.TCategoria.State =DsInsert then
begin
  if findkey([x]) then result:=true
  else result:=false;
end;
close;
free;
end;
end;


procedure TFCategoria.tabelavazia;
begin
if datamodule1.TCategoria.recordcount<1 then
begin
  novo.enabled:=true;
  editar.enabled:=false;
  deletar.enabled:=false;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
end
else begin
  novo.enabled:=true;
  editar.enabled:=true;
  deletar.enabled:=true;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  navegador.enabled:=true;
end;
end;

procedure TFCategoria.botoes;
begin
novo.enabled:=false;
editar.enabled:=false;
deletar.Enabled:=false;
cancelar.enabled:=true;
gravar.enabled:=true;
navegador.enabled:=editar.enabled;
end;


procedure TFCategoria.novoClick(Sender: TObject);
var x:integer;
begin
DataModule1.TCategoria.Last;
x := (DataModule1.TCategoria.FieldByName('CatCodigo').AsInteger + 1);
datamodule1.DSCategoria.AutoEdit:=true;
datamodule1.TCategoria.Insert;
DataModule1.TCategoria.FieldByName('CatCodigo').AsInteger := x;
dbedit1.setfocus;
botoes;
end;

procedure TFCategoria.editarClick(Sender: TObject);
begin
velho:=strtoint(dbedit1.text);
precovelho := DataModule1.TCategoria.FieldByName('CatValor').asFloat;
datamodule1.TCategoria.Edit;
datamodule1.DSCategoria.AutoEdit:=true;
//controla botoes enabled
botoes;
dbedit1.setfocus;
end;

procedure TFCategoria.deletarClick(Sender: TObject);
begin
DataModule1.TFilmes.IndexName := 'FilCategoria';
if DataModule1.TFilmes.FindKey([DataModule1.TCategoria.FieldByName('CatCodigo').asInteger]) then
begin
   ShowMessage('Categoria Vinculada na Tabela de Filmes');
end
else begin
if MessageDlg('EXCLUIR O REGISTRO?', mtConfirmation, [mbYes,mbNo], 0)=mrYes then
begin
  datamodule1.TCategoria.delete;
end;
tabelavazia;
end;

end;

procedure TFCategoria.cancelarClick(Sender: TObject);
begin
datamodule1.TCategoria.Cancel;
//controla botoes enabled
novo.enabled:=true;
editar.enabled:=true;
deletar.enabled:=true;
cancelar.Enabled:=false;
gravar.Enabled:=false;
navegador.enabled:=true;
tabelavazia;
end;

procedure TFCategoria.gravarClick(Sender: TObject);
var pos : integer;
begin
if (not duplicado(strtoint(dbedit1.text))) then
begin
  novo.enabled:=true;
  editar.enabled:=true;
  deletar.enabled:=true;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  navegador.Enabled:=true;
  DataModule1.TCategoria.post;
  if precovelho<>(DataModule1.TCategoria.FieldByName('CatValor').asFloat) then
  begin
    with DataModule1.TFilmes do
    begin
      pos:=DataModule1.TCategoria.RecNo;
      first;
      while not eof do
      begin
        if FieldByName('FilCategoria').asInteger = StrToInt(DBEdit1.Text) then
        begin
          edit;
          FieldByName('FilValorCategoria').asFloat := DataModule1.TCategoria.FieldByName('CatValor').asFloat;
          post;
        end;
        next;
       end;
       DataModule1.TCategoria.RecNo := pos;
    end;
  end;
  datamodule1.TCategoria.IndexFieldNames := '';
  DataModule1.DsCategoria.AutoEdit := false;
end
else begin
  showmessage('Registro duplicado');
  dbedit1.setfocus;
end;
end;

procedure TFCategoria.BitBtn2Click(Sender: TObject);
begin
close;
end;

procedure TFCategoria.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if (datamodule1.TCategoria.State= dsinsert) or (datamodule1.TCategoria.State = dsEdit)
then datamodule1.TCategoria.Cancel;
end;

procedure TFCategoria.FormShow(Sender: TObject);
begin
datamodule1.TCategoria.First;
datamodule1.DSCategoria.AutoEdit:=false;
//controla botoes enabled
tabelavazia;
end;

end.
